#include <stdio.h>

typedef int (*summ_t) ( int );
int summ2( int x ) { return x + 2; }
int summ3( int x ) { return x + 3; }
int summ4( int x ) { return x + 4; }

summ_t funcs[] = { summ2, summ3, summ4 };

int call( summ_t func, void *data ) {
   return func( *(int*)data );
}

void set1( int x ) { x++; }
void set2( int* x ) { (*x)++; }

//------------------------------------------

#define N 10
typedef struct {
   int x[ N ];
} astruct_t;

astruct_t revers( astruct_t s ) {
   int n, i, j;
   n = sizeof( s ) / sizeof( int );
   for( i = 0, j = n - 1; i < j; i++, j-- ) {
      int var = s.x[ i ];
      s.x[ i ] = s.x[ j ];
      s.x[ j ] = var;
   } 
   return s;
}

void show_ba( astruct_t* b, astruct_t* a ) {
   int i;
   printf( "before: " );
   for( i = 0; i < N; i++ ) 
      printf( "%d%s", b->x[ i ], i != N - 1 ? ", " : ""  );
   printf( " | after: " );
   for( i = 0; i < N; i++ ) 
      printf( "%d%s", a->x[ i ], i != N - 1 ? ", " : ""  );
   printf( "\n" );
}

//------------------------------------------

void mod( astruct_t* s ) {
   int n = sizeof( *s ) / sizeof( int );
   void pow2( void ) {
      int i;
      for( i = 0; i < n; i++ ) 
         s->x[ i ] *= s->x[ i ];
   } 
   pow2();
   return;
}

//------------------------------------------


// функции и вызовы:
int main () {
   int i;
//------------------------------------------
   for( i = 0; i < sizeof( funcs ) / sizeof( funcs[ 0 ] ); i++ )
      printf( "%d ", funcs[ i ]( i ) );
   printf( "\n" );
//------------------------------------------
   summ_t summ2_2 = summ2;
   printf( "%d ", summ2_2( 7 ) );
   for( i = 0; i < sizeof( funcs ) / sizeof( funcs[ 0 ] ); i++ ) {
      summ2_2 = funcs[ i ];
      printf( "%d ", summ2_2( 7 ) );
   }
   printf( "\n" );
//------------------------------------------
   i = 3;
   int *pi = &i;
   printf( "косвенный вызов: %d\n", call( summ3, &i ) );
   set1( i );
   printf( "передача параметра: по значению -> %d,", i );
   set2( pi );
   printf( " по ссылке -> %d\n", i );
//------------------------------------------
   astruct_t before = {{ 1, 2, 3, 4, 5, 6, 7 }},
             after = {{ 10*(0) }};
   show_ba( &before, &after );
   printf( "revers ... ... ...\n" );
   after = revers( before );
   show_ba( &before, &after );
//------------------------------------------
   after = before;
   mod( &after );
   printf( "вложенные описания функций (GCC):\n" );
   show_ba( &before, &after );
//------------------------------------------
   return 0;
}
